<template>
  <input class="text-input" v-bind="{...$attrs, ...$props}" :placeholder="placeholderText" v-model="state.textValue" @mousedown="$emit('openOptionList')" @focusout="$emit('closeOptionList')">
</template>

<script>
import {reactive, watch} from "vue";

export default {
  props: {
    placeholderText: {
      type: String,
      default: 'Add tags...',
      required: false
    },
    onTextChange: {
      type: Function,
      default: inp => inp
    },
    onTextFieldFocus: Function
  },
  name: "BaseTextInput",
  setup(props){
    const state = reactive({
      textValue: ''
    })

    watch(state, (currentValue) => {
      props.onTextChange(currentValue.textValue)
    })
    return {
      state
    }
  }
}
</script>

<style scoped lang="scss">
@import "../../styles/sizes";
@import "../../styles/colors";

.text-input {
  outline: 0;
  background-color: white;
  height: 36px;
  padding: 8px;
  border-radius: 8px;
  font-size: $normal;
  box-shadow: 0 4px 8px -2px rgba(27, 46, 94, 0.04);

  &::placeholder {
    color: $light_gray;
  }
}
</style>